COMMENT *

CpuLoad Control (ProgressBar style) v0.9

(c) Copyright of joerg hohaus (April 2005) 
---> using WinAsm Studio [(c) Copyright of Antonis Kyprianou (2003-2005)] <---

Dependencies: Needs Windows (c) NT 4.0 or better
              GDIplus.dll required (code uses gdi+ flat api!)
              Hardware support for high performace counters required
              
Limitations:  - Still under construction (BETA to the power of 10 ;-)
                
Please notice that i am a beginner in assembly coding. I have tested this coded carefully but
i am not responsible for any damage caused by this code!!

Please feel free to report bugs, suggestions and advices on the forum at www.winasm.net or
EMail: jhohaus@web.de (plz use 'CPULoad WinASM' as subject!)

Release: 05/08/2005   *


.486
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE

Include CpuLoadInt.inc
Include PdhProcs.asm
Include GfxProcs.asm

Include LogWrite.asm


.CODE

DllEntry Proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD

	.If reason==DLL_PROCESS_ATTACH
	;-- Create and register control class
		Invoke InitCLPGControl,hInst
	.ElseIf reason==DLL_PROCESS_DETACH
		Invoke UnregisterClass,Offset szControlClass,hInst
	.EndIf
	mov EAX,TRUE
	ret

DllEntry EndP


InitCLPGControl Proc hInst:HINSTANCE
Local wc:WNDCLASSEX

	MOV wc.cbSize,SizeOf WNDCLASSEX
	MOV wc.style,CS_GLOBALCLASS
	MOV wc.lpfnWndProc,Offset CustomControlProc
	MOV wc.cbClsExtra,0
	MOV wc.cbWndExtra,4			; reserved for pointer to control structure
	MOV EAX,hInst
	MOV wc.hInstance,EAX
	Invoke LoadCursor,NULL,IDC_ICON
	MOV wc.hCursor,EAX
	MOV wc.hbrBackground,COLOR_WINDOW+1
	MOV wc.lpszMenuName,NULL
	MOV wc.lpszClassName,Offset szControlClass
	MOV wc.hIcon,NULL
	MOV wc.hIconSm,NULL
	
	Invoke RegisterClassEx,ADDR wc
	
	ret
	
InitCLPGControl EndP

CustomControlProc Proc USES ebx hCtrl:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

Local hDC:HDC
Local ps:PAINTSTRUCT 

	mov eax,uMsg
	.IF eax == WM_NCCREATE
	;-- startup gdiplus.dll when first control is created -- thanks Antonis Kyprianou !!
		.if dwControlCount == 0
			Invoke GdiplusStartup,ADDR hGDIplus,ADDR GdiPlusSI,NULL
		.endif
		add dwControlCount,1
	;-- allocate memory for structure and store it in cbWndExtra
		Invoke GlobalAlloc,GPTR,SIZEOF(CpuPgBar)
		Invoke SetWindowLong,hCtrl,0,eax
		Invoke GetWindowLong,hCtrl,0
		mov ebx,eax
		ASSUME ebx:PTR CpuPgBar
		mov ecx,hCtrl                ; Store control handle
		mov [ebx].hWndCtrl,ecx
		ASSUME ebx:NOTHING
		mov eax,TRUE
		ret
	.ELSEIF eax == WM_NCDESTROY
	;-- free memory allocated for structure
		Invoke GetWindowLong,hCtrl,0
		Invoke GlobalFree,eax
		sub dwControlCount,1
	;-- if last control was destroyed, close gdiplus.dll -- thanks Antonis Kyprianou !!
		.if dwControlCount == 0
			Invoke GdiplusShutdown,hGDIplus
		.endif
		mov eax,FALSE
		ret
	.ELSEIF EAX ==WM_CREATE
		Invoke InitGDIp,hCtrl
	;-- Create font, NULL determines font of parent window
		Invoke InitFont,hCtrl,0
		
	.ELSEIF	eax == WM_DESTROY
	;-- Clean up gdi+ classes
		Invoke CleanUpGDIp,hCtrl
;--------------------------------------------------------------------------
;-- PRIVATE MESSAGES
;--------------------------------------------------------------------------
	;-- Set minimum and maximum value
	.ELSEIF	eax == WM_CLPG_SET_RANGE
		Invoke SetControlRange,hCtrl,wParam,lParam
		
	;-- advances the current position by a specified increment
	.ELSEIF	eax == WM_CLPG_SET_DELTA
	
	;-- specifies the step increment
	.ELSEIF	eax == WM_CLPG_SET_STEP
		invoke SetControlStep,hCtrl,lParam
		
	;-- advances the current position by the step increment
	.ELSEIF	eax == WM_CLPG_STEPIT
		invoke SetControlStepIt,hCtrl,lParam
		
	;-- WM_CLPG_SET_NEWVALUE message used for custom values		
	.ELSEIF EAX == WM_CLPG_SET_POS
		Invoke SetControlNewValue,hCtrl,lParam
		
	;-- WM_CLPG_NEW_DATA message used for CPU-Load		
	.ELSEIF EAX == WM_CLPG_NEW_DATA
		
		Invoke InvalidateRect,hCtrl,NULL,TRUE
		
	;-- Set control colors passed by lParam
	.ELSEIF EAX == WM_CLPG_SET_BACKCOLOR
		Invoke SetControlColor,hCtrl,lParam,CLPG_BACKCOLOR
	.ELSEIF EAX == WM_CLPG_SET_COLOR000
		Invoke SetControlColor,hCtrl,lParam,CLPG_COLOR000
	.ELSEIF EAX == WM_CLPG_SET_COLOR050
		Invoke SetControlColor,hCtrl,lParam,CLPG_COLOR050
	.ELSEIF EAX == WM_CLPG_SET_COLOR100
		Invoke SetControlColor,hCtrl,lParam,CLPG_COLOR100
	.ELSEIF EAX == WM_CLPG_SET_TEXTCOLOR
		Invoke SetControlColor,hCtrl,lParam,CLPG_TEXTCOLOR
		
	;-- Set control font
	.ELSEIF EAX == WM_CLPG_SET_FONT
    	Invoke CleanUpGDIp,hCtrl
		Invoke InitGDIp,hCtrl		
		Invoke InitFont,hCtrl,lParam
		
	;-- Set control fontsize
	.ELSEIF EAX == WM_CLPG_SET_FONTSIZE
		invoke SetCtrlFontSize,hCtrl,lParam

	.ELSEIF uMsg==WM_PAINT 
        Invoke BeginPaint,hCtrl,ADDR ps 
		Invoke DrawGDIp,hCtrl
        Invoke EndPaint,hCtrl,ADDR ps
        
    .ELSEIF uMsg==WM_WINDOWPOSCHANGED
    	Invoke CleanUpGDIp,hCtrl
		Invoke InitGDIp,hCtrl
		Invoke InitFont,hCtrl,NULL
        ret
	;--        
	.ELSEIF uMsg == WM_ERASEBKGND
		mov eax,TRUE
		ret
		
	.ELSE
		Invoke DefWindowProc,hCtrl,uMsg,wParam,lParam
		RET
	.ENDIF
	XOR EAX,EAX
	RET
CustomControlProc EndP

SetControlStepIt PROC USES ebx hWnd:DWORD,bSpin:DWORD

	Invoke GetWindowLong,hWnd,0
	mov ebx,eax
	ASSUME ebx:PTR CpuPgBar
	
	mov eax,[ebx].dwStyle	; check for CpuLoad-Style
	and eax,CLPG_CPULOAD
	jnz _errorCPU			; ignore message for CpuLoad-Style
	
	mov eax,[ebx].dwValue
	add eax,[ebx].dwStep
	;-- set value depending on spinmode
	.if bSpin == TRUE
		.if SDWORD PTR eax > SDWORD PTR [ebx].dwMaxVal
			mov eax,0[ebx].dwMinVal	; start again
		.endif
	.else
		.if SDWORD PTR eax > SDWORD PTR [ebx].dwMaxVal
			mov eax,[ebx].dwMaxVal 	; set to max value
		.endif
	.endif
	
	mov [ebx].dwValue,eax
	sub SDWORD PTR eax,[ebx].dwMinVal
	mov [ebx].dwRelPos,eax
	Invoke dwtoa,[ebx].dwValue,ADDR [ebx].szBuffer
	Invoke StrLen,ADDR [ebx].szBuffer
	mov [ebx].dwStrLen,eax
	Invoke MultiByteToWideChar,CP_ACP,0,ADDR [ebx].szBuffer,-1,ADDR [ebx].szWBuffer,[ebx].dwStrLen
	Invoke InvalidateRect,hWnd,NULL,TRUE
	
_errorCPU:
	ASSUME ebx:NOTHING
	Ret
SetControlStepIt EndP

SetControlStep PROC USES ebx hWnd:DWORD,dwStepSize:DWORD

	Invoke GetWindowLong,hWnd,0
	mov ebx,eax
	ASSUME ebx:PTR CpuPgBar
		
	xor eax,eax
	add eax,dwStepSize
	js _exit				; ignore negative values
	jz _exit				; ignore zero values 
	mov edx,[ebx].dwRange
	cmp eax,edx
	jge _exit				; ignore if Step >= Range
	mov [ebx].dwStep,eax	; store step
	
;-- we have custom step size
    or [ebx].dwCustomInfo,CPLG_INFO_CUSTOMSTEP
_exit:
	ASSUME ebx:NOTHING	
	Ret
SetControlStep EndP

SetControlNewValue PROC uses ebx hWnd:DWORD,dwValue:DWORD

	Invoke GetWindowLong,hWnd,0
	mov ebx,eax
	ASSUME ebx:PTR CpuPgBar
	
	mov eax,[ebx].dwStyle	; check for CpuLoad-Style
	and eax,CLPG_CPULOAD
	jnz _errorCPU			; ignore message for CpuLoad-Style
	
	mov eax,dwValue
	.if SDWORD PTR eax > SDWORD PTR [ebx].dwMaxVal
		mov eax,[ebx].dwMaxVal
	.elseif SDWORD PTR eax < SDWORD PTR [ebx].dwMinVal
		mov eax,[ebx].dwMinVal
	.endif
	
	mov [ebx].dwValue,eax
	sub SDWORD PTR eax,[ebx].dwMinVal
	mov [ebx].dwRelPos,eax
	Invoke dwtoa,[ebx].dwValue,ADDR [ebx].szBuffer
	Invoke StrLen,ADDR [ebx].szBuffer
	mov [ebx].dwStrLen,eax
	Invoke MultiByteToWideChar,CP_ACP,0,ADDR [ebx].szBuffer,-1,ADDR [ebx].szWBuffer,[ebx].dwStrLen
	Invoke InvalidateRect,hWnd,NULL,TRUE
	
_errorCPU:	
	ASSUME ebx:NOTHING
	Ret
SetControlNewValue EndP

SetControlColor PROC uses ebx hWnd:DWORD,dwColor:DWORD,dwCType:DWORD

	;-- Set custom back color, passed using lParam
	Invoke GetWindowLong,hWnd,0
	mov ebx,eax
	ASSUME ebx:PTR CpuPgBar
		
	Invoke CleanUpGDIp,hWnd
	mov ecx,dwColor
	
	.if dwCType == CLPG_BACKCOLOR
		mov [ebx].dwColorBckgr,ecx
	.elseif dwCType == CLPG_COLOR000
		mov [ebx].dwColor000,ecx
	.elseif dwCType == CLPG_COLOR050
		mov [ebx].dwColor050,ecx
	.elseif dwCType == CLPG_COLOR100
		mov [ebx].dwColor100,ecx
	.elseif dwCType == CLPG_TEXTCOLOR
		mov [ebx].dwColorText,ecx	
	.endif
	
;-- we have custom color
    or [ebx].dwCustomInfo,CPLG_INFO_CUSTOMFORECOLORS
;-- reinitialize Control
	Invoke InitGDIp,hWnd
	Invoke InitFont,hWnd,NULL
	Invoke InvalidateRect,hWnd,NULL,TRUE
	ASSUME ebx:NOTHING

	Ret
SetControlColor EndP

SetCtrlFontSize PROC USES ebx hWnd:DWORD,dwNewSize:DWORD

	;-- Set custom back color, passed using lParam
	Invoke GetWindowLong,hWnd,0
	mov ebx,eax
	ASSUME ebx:PTR CpuPgBar
		
	Invoke CleanUpGDIp,hWnd
	mov eax,dwNewSize
	cmp eax,100
	jle @F
	mov eax,100
	@@:
	mov [ebx].dwFontSize,eax
	or [ebx].dwCustomInfo,CPLG_INFO_CUSTOMFONTSIZE
	Invoke InitGDIp,hWnd
	Invoke InitFont,hWnd,NULL
	Invoke InvalidateRect,hWnd,NULL,TRUE
	
	ASSUME ebx:NOTHING
	Ret
	
SetCtrlFontSize EndP

SetControlRange PROC USES ebx hWnd:DWORD,sdwLowBound:SDWORD,sdwUpBound:SDWORD

	Invoke GetWindowLong,hWnd,0
	mov ebx,eax
	ASSUME ebx:PTR CpuPgBar

	mov eax,[ebx].dwStyle	; check for CpuLoad-Style
	and eax,CLPG_CPULOAD
	jnz _errorCPU			; ignore message for CpuLoad-Style

	Invoke CleanUpGDIp,hWnd
	
;-- check parameter validity
	mov edx,sdwLowBound    ; lower bound in edx
	mov ecx,sdwUpBound     ; upper bound in ecx
	cmp SDWORD PTR edx,ecx
	je _error	           ; the values are equal, exit
	jl @F                  ; sdwLowBound < sdwUpBound, OK
	mov ecx,sdwLowBound    ; exchange parameters
	mov edx,sdwUpBound
	@@:

	mov [ebx].dwMinVal,edx
	mov [ebx].dwMaxVal,ecx
	sub edx,ecx				; sdwLowBound - sdwUpBound = Range
	jns @F
	neg edx
	@@:
	mov [ebx].dwRange,edx
	mov [ebx].dwValue,edx
	or [ebx].dwCustomInfo,CPLG_INFO_CUSTOMRANGE
_error:
	Invoke InitGDIp,hWnd
	Invoke InitFont,hWnd,NULL
	Invoke InvalidateRect,hWnd,NULL,TRUE
	
_errorCPU:
	ASSUME ebx:NOTHING
	Ret
SetControlRange EndP

InitCLPGCtrl PROC

;--------------------------------------------------------------------
; Dummy proc. Referencing this instruction anywhere in the code
; will load the lib and register the class
;--------------------------------------------------------------------

	xor eax, eax       ; return OK
    ret
InitCLPGCtrl ENDP 

End DllEntry