
; Public [exported] functions
InitCLPGCtrl               PROTO
ClpgSetForeColors          PROTO :DWORD,:DWORD
ClpgGetData                PROTO :DWORD,:DWORD
ClpgSetData                PROTO :DWORD,:DWORD

; CPULoad control Styles
CLPG_CPULOAD               EQU 1H               ; use control to show CPU-Load 
CLPG_HATCHSTYLEVERTICAL    EQU 2H               ; draw vertical lines
CLPG_ORIENTATIONVERTICAL   EQU 4H               ; TODO: draw control with vertical orientation
CLPG_NOTEXT                EQU 8H               ; disables text
CLPG_PARTIAL               EQU 10H              ; shows partial progress bar

; External user messages
WM_CLPG_SET_BACKCOLOR      EQU WM_USER + 101h   ; Set back color (Color = lParam)
WM_CLPG_SET_COLOR000       EQU WM_USER + 102h   ; Set color at 0% (Color = lParam)
WM_CLPG_SET_COLOR050       EQU WM_USER + 103h   ; Set color at 50% (Color = lParam)
WM_CLPG_SET_COLOR100       EQU WM_USER + 104h   ; Set color at 1000% (Color = lParam)
WM_CLPG_SET_NEWVALUE       EQU WM_USER + 105h   ; Set control value (Value = lParam)
WM_CLPG_SET_TEXTCOLOR      EQU WM_USER + 106h   ; Set text color (Color = lParam)
WM_CLPG_SET_FONT           EQU WM_USER + 107h   ; Set control font (PtrFontName = lParam)
WM_CLPG_SET_FONTSIZE       EQU WM_USER + 108h   ; Set fontsize in percent of control height (Color = lParam)
WM_CLPG_SET_RANGE          EQU WM_USER + 109h   ; Sets the minimum and maximum  value
WM_CLPG_SET_DELTA          EQU WM_USER + 110h   ; Advance Position relative to the current one (value = lParam)
WM_CLPG_SET_STEP           EQU WM_USER + 111h   ; Specifies the step increment for a WM_CLPG_STEPIT message (dwStep = lParam)
WM_CLPG_STEPIT             EQU WM_USER + 112h   ; Advances current position by the step increment and redraws the bar 

CPLG_FORECOLORS Struct

    ForeColor000          DWORD ?
    ForeColor050          DWORD ?
    ForeColor100          DWORD ?
    
CPLG_FORECOLORS EndS

CPLG_DATA Struct
	;Colors
    dwForeColor000        DWORD ?
    dwForeColor050        DWORD ?
    dwForeColor100        DWORD ?
    dwColorText           DWORD ?        ; Text color
    dwColorBckgr          DWORD ?
    ;Font
    dwFontSize            DWORD ?        ; Fontsize (in percent)
    szwFontName           WORD 36 DUP (?); Buffer for font name (unicode)
    
CPLG_DATA EndS

;; Common color definitions - ARGB
;; these EQU's are included in gdiplus_structures_ver0.inc also
;; included for faster review only
;ColorsAliceBlue            EQU 0FFF0F8FFh
;ColorsAntiqueWhite         EQU 0FFFAEBD7h
;ColorsAqua                 EQU 0FF00FFFFh
;ColorsAquamarine           EQU 0FF7FFFD4h
;ColorsAzure                EQU 0FFF0FFFFh
;ColorsBeige                EQU 0FFF5F5DCh
;ColorsBisque               EQU 0FFFFE4C4h
;ColorsBlack                EQU 0FF000000h
;ColorsBlanchedAlmond       EQU 0FFFFEBCDh
;ColorsBlue                 EQU 0FF0000FFh
;ColorsBlueViolet           EQU 0FF8A2BE2h
;ColorsBrown                EQU 0FFA52A2Ah
;ColorsBurlyWood            EQU 0FFDEB887h
;ColorsCadetBlue            EQU 0FF5F9EA0h
;ColorsChartreuse           EQU 0FF7FFF00h
;ColorsChocolate            EQU 0FFD2691Eh
;ColorsCoral                EQU 0FFFF7F50h
;ColorsCornflowerBlue       EQU 0FF6495EDh
;ColorsCornsilk             EQU 0FFFFF8DCh
;ColorsCrimson              EQU 0FFDC143Ch
;ColorsCyan                 EQU 0FF00FFFFh
;ColorsDarkBlue             EQU 0FF00008Bh
;ColorsDarkCyan             EQU 0FF008B8Bh
;ColorsDarkGoldenrod        EQU 0FFB8860Bh
;ColorsDarkGray             EQU 0FFA9A9A9h
;ColorsDarkGreen            EQU 0FF006400h
;ColorsDarkKhaki            EQU 0FFBDB76Bh
;ColorsDarkMagenta          EQU 0FF8B008Bh
;ColorsDarkOliveGreen       EQU 0FF556B2Fh
;ColorsDarkOrange           EQU 0FFFF8C00h
;ColorsDarkOrchid           EQU 0FF9932CCh
;ColorsDarkRed              EQU 0FF8B0000h
;ColorsDarkSalmon           EQU 0FFE9967Ah
;ColorsDarkSeaGreen         EQU 0FF8FBC8Bh
;ColorsDarkSlateBlue        EQU 0FF483D8Bh
;ColorsDarkSlateGray        EQU 0FF2F4F4Fh
;ColorsDarkTurquoise        EQU 0FF00CED1h
;ColorsDarkViolet           EQU 0FF9400D3h
;ColorsDeepPink             EQU 0FFFF1493h
;ColorsDeepSkyBlue          EQU 0FF00BFFFh
;ColorsDimGray              EQU 0FF696969h
;ColorsDodgerBlue           EQU 0FF1E90FFh
;ColorsFirebrick            EQU 0FFB22222h
;ColorsFloralWhite          EQU 0FFFFFAF0h
;ColorsForestGreen          EQU 0FF228B22h
;ColorsFuchsia              EQU 0FFFF00FFh
;ColorsGainsboro            EQU 0FFDCDCDCh
;ColorsGhostWhite           EQU 0FFF8F8FFh
;ColorsGold                 EQU 0FFFFD700h
;ColorsGoldenrod            EQU 0FFDAA520h
;ColorsGray                 EQU 0FF808080h
;ColorsGreen                EQU 0FF008000h
;ColorsGreenYellow          EQU 0FFADFF2Fh
;ColorsHoneydew             EQU 0FFF0FFF0h
;ColorsHotPink              EQU 0FFFF69B4h
;ColorsIndianRed            EQU 0FFCD5C5Ch
;ColorsIndigo               EQU 0FF4B0082h
;ColorsIvory                EQU 0FFFFFFF0h
;ColorsKhaki                EQU 0FFF0E68Ch
;ColorsLavender             EQU 0FFE6E6FAh
;ColorsLavenderBlush        EQU 0FFFFF0F5h
;ColorsLawnGreen            EQU 0FF7CFC00h
;ColorsLemonChiffon         EQU 0FFFFFACDh
;ColorsLightBlue            EQU 0FFADD8E6h
;ColorsLightCoral           EQU 0FFF08080h
;ColorsLightCyan            EQU 0FFE0FFFFh
;ColorsLightGoldenrodYellow EQU 0FFFAFAD2h
;ColorsLightGray            EQU 0FFD3D3D3h
;ColorsLightGreen           EQU 0FF90EE90h
;ColorsLightPink            EQU 0FFFFB6C1h
;ColorsLightSalmon          EQU 0FFFFA07Ah
;ColorsLightSeaGreen        EQU 0FF20B2AAh
;ColorsLightSkyBlue         EQU 0FF87CEFAh
;ColorsLightSlateGray       EQU 0FF778899h
;ColorsLightSteelBlue       EQU 0FFB0C4DEh
;ColorsLightYellow          EQU 0FFFFFFE0h
;ColorsLime                 EQU 0FF00FF00h
;ColorsLimeGreen            EQU 0FF32CD32h
;ColorsLinen                EQU 0FFFAF0E6h
;ColorsMagenta              EQU 0FFFF00FFh
;ColorsMaroon               EQU 0FF800000h
;ColorsMediumAquamarine     EQU 0FF66CDAAh
;ColorsMediumBlue           EQU 0FF0000CDh
;ColorsMediumOrchid         EQU 0FFBA55D3h
;ColorsMediumPurple         EQU 0FF9370DBh
;ColorsMediumSeaGreen       EQU 0FF3CB371h
;ColorsMediumSlateBlue      EQU 0FF7B68EEh
;ColorsMediumSpringGreen    EQU 0FF00FA9Ah
;ColorsMediumTurquoise      EQU 0FF48D1CCh
;ColorsMediumVioletRed      EQU 0FFC71585h
;ColorsMidnightBlue         EQU 0FF191970h
;ColorsMintCream            EQU 0FFF5FFFAh
;ColorsMistyRose            EQU 0FFFFE4E1h
;ColorsMoccasin             EQU 0FFFFE4B5h
;ColorsNavajoWhite          EQU 0FFFFDEADh
;ColorsNavy                 EQU 0FF000080h
;ColorsOldLace              EQU 0FFFDF5E6h
;ColorsOlive                EQU 0FF808000h
;ColorsOliveDrab            EQU 0FF6B8E23h
;ColorsOrange               EQU 0FFFFA500h
;ColorsOrangeRed            EQU 0FFFF4500h
;ColorsOrchid               EQU 0FFDA70D6h
;ColorsPaleGoldenrod        EQU 0FFEEE8AAh
;ColorsPaleGreen            EQU 0FF98FB98h
;ColorsPaleTurquoise        EQU 0FFAFEEEEh
;ColorsPaleVioletRed        EQU 0FFDB7093h
;ColorsPapayaWhip           EQU 0FFFFEFD5h
;ColorsPeachPuff            EQU 0FFFFDAB9h
;ColorsPeru                 EQU 0FFCD853Fh
;ColorsPink                 EQU 0FFFFC0CBh
;ColorsPlum                 EQU 0FFDDA0DDh
;ColorsPowderBlue           EQU 0FFB0E0E6h
;ColorsPurple               EQU 0FF800080h
;ColorsRed                  EQU 0FFFF0000h
;ColorsRosyBrown            EQU 0FFBC8F8Fh
;ColorsRoyalBlue            EQU 0FF4169E1h
;ColorsSaddleBrown          EQU 0FF8B4513h
;ColorsSalmon               EQU 0FFFA8072h
;ColorsSandyBrown           EQU 0FFF4A460h
;ColorsSeaGreen             EQU 0FF2E8B57h
;ColorsSeaShell             EQU 0FFFFF5EEh
;ColorsSienna               EQU 0FFA0522Dh
;ColorsSilver               EQU 0FFC0C0C0h
;ColorsSkyBlue              EQU 0FF87CEEBh
;ColorsSlateBlue            EQU 0FF6A5ACDh
;ColorsSlateGray            EQU 0FF708090h
;ColorsSnow                 EQU 0FFFFFAFAh
;ColorsSpringGreen          EQU 0FF00FF7Fh
;ColorsSteelBlue            EQU 0FF4682B4h
;ColorsTan                  EQU 0FFD2B48Ch
;ColorsTeal                 EQU 0FF008080h
;ColorsThistle              EQU 0FFD8BFD8h
;ColorsTomato               EQU 0FFFF6347h
;ColorsTransparent          EQU 0FFFFFFh
;ColorsTurquoise            EQU 0FF40E0D0h
;ColorsViolet               EQU 0FFEE82EEh
;ColorsWheat                EQU 0FFF5DEB3h
;ColorsWhite                EQU 0FFFFFFFFh
;ColorsWhiteSmoke           EQU 0FFF5F5F5h
;ColorsYellow               EQU 0FFFFFF00h
;ColorsYellowGreen          EQU 0FF9ACD32h