.CODE

DlgColor proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
Local hList:HANDLE
Local hTmp:HANDLE

	.if uMsg == WM_INITDIALOG
		mov eax,hWin
		mov hDlgColor,eax
	;-- Handle to CPLG-control we are working on
		mov eax,lParam
		mov hDlgCtrl,eax
	;-- Initialize GDIplus
		Invoke GdiplusStartup,ADDR hGDIplus,ADDR GdiPlusSI,NULL
	;-- Set first radiobutton to checked state
		Invoke GetDlgItem,hWin,IDC_RB_FC0
		mov edx,eax
		Invoke SendMessage,edx,BM_SETCHECK,BST_CHECKED,0
		mov dwCurRB,0
	;-- Retrieve and store image control handles
		Invoke GetDlgItem,hWin,IDC_IMG_FC0
		mov hImg.hImg000,eax
		mov hImg.hImgCur,eax
		Invoke SetWindowLong,hImg.hImg000,GWL_WNDPROC,ImageProc000
		mov lpImg000,eax
		Invoke GetDlgItem,hWin,IDC_IMG_FC50
		mov hImg.hImg050,eax
		Invoke SetWindowLong,hImg.hImg050,GWL_WNDPROC,ImageProc050
		mov lpImg050,eax
		Invoke GetDlgItem,hWin,IDC_IMG_FC100
		mov hImg.hImg100,eax
		Invoke SetWindowLong,hImg.hImg100,GWL_WNDPROC,ImageProc100
		mov lpImg100,eax		
		Invoke GetDlgItem,hWin,IDC_IMG_BC
		mov hImg.hImgBck,eax
		Invoke SetWindowLong,hImg.hImgBck,GWL_WNDPROC,ImageProcBck
		mov lpImgBck,eax
		Invoke GetDlgItem,hWin,IDC_IMG_TC
		mov hImg.hImgTxt,eax
		Invoke SetWindowLong,hImg.hImgTxt,GWL_WNDPROC,ImageProcTxt
		mov lpImgTxt,eax
		
	;-- fill listbox with named colors
		Invoke GetDlgItem,hWin,IDC_LISTBOX
		mov hList,eax
		Invoke SetWindowLong,hList,GWL_WNDPROC,ListBoxProc
		mov lpListBox,eax
		
		mov ecx,141             ; initialize counter (# of strings)
		push ebx                ; preserve ebx
		lea ebx,szAliceBlue     ; address of first string
		@@:
			push ecx
			Invoke SendMessage,hList,LB_ADDSTRING,0,ebx
			Invoke StrLen,ebx   ; get length of current string 
			add ebx,eax
			add ebx,1           ; address of next string
			pop ecx
			sub ecx,1           ; increase counter 
			jz @F               ; done?
			jmp @B              ; next string
		@@:
		pop ebx
		
		Invoke CreateFontBold,hWin,IDC_B_Cancel
		mov hFont,eax
		Invoke SetControlFont,hWin,IDC_B_Cancel
		Invoke SetControlFont,hWin,IDC_B_Apply
		Invoke SetControlFont,hWin,IDC_B_Reset
		Invoke SetControlFont,hWin,IDC_GROUPBOX
		Invoke SetControlFont,hWin,IDC_GROUPBOX2
		Invoke SetControlFont,hWin,IDC_GROUPBOX1047
	;-- Retrieve settings of control to modify
		Invoke GetClpgSettings,hDlgCtrl
		Invoke SetListColor,IDC_RB_FC0
	;-- Show preview control with same settings
		Invoke GetDlgItem,hWin,IDC_CPULOAD
		mov hTmp,eax
		invoke ClpgSetData,hTmp,ADDR clpgDNew
		Invoke PostMessage,hTmp,WM_CLPG_SET_NEWVALUE,0,95
		
	.elseif	uMsg == WM_COMMAND
	;-- buttons message processing
        .if	wParam == IDC_B_Cancel       ; Cancel
			Invoke EndDialog,hWin,0
			
		.elseif wParam == IDC_B_Apply    ; Apply customized settings
			invoke ClpgSetData,hDlgCtrl,ADDR clpgDNew
			Invoke EndDialog,hWin,0
		
		.elseif wParam == IDC_B_Reset    ; Reset to control settings
			Invoke GetClpgSettings,hDlgCtrl
			Invoke InvalidateRect,hImg.hImg000,0,TRUE
			Invoke InvalidateRect,hImg.hImg050,0,TRUE
			Invoke InvalidateRect,hImg.hImg100,0,TRUE
			Invoke InvalidateRect,hImg.hImgBck,0,TRUE
			Invoke InvalidateRect,hImg.hImgTxt,0,TRUE
	;-- Radiobuttons message processing
		.elseif wParam == IDC_RB_FC0     ; Radio button forecolor 0%
			Invoke GetDlgItem,hWin,IDC_IMG_FC0
			mov hImg.hImgCur,eax
			mov dwCurRB,0
			Invoke SetListColor,IDC_RB_FC0
		.elseif wParam == IDC_RB_FC50    ; Radio button forecolor 50%
			Invoke GetDlgItem,hWin,IDC_IMG_FC50
			mov hImg.hImgCur,eax
			mov dwCurRB,1
			Invoke SetListColor,IDC_RB_FC50
		.elseif wParam == IDC_RB_FC100   ; Radio button forecolor 100%
			Invoke GetDlgItem,hWin,IDC_IMG_FC100
			mov hImg.hImgCur,eax
			mov dwCurRB,2
			Invoke SetListColor,IDC_RB_FC100
		.elseif wParam == IDC_RB_BC      ; Radio button backcolor
			Invoke GetDlgItem,hWin,IDC_IMG_BC
			mov hImg.hImgCur,eax
			mov dwCurRB,3
			Invoke SetListColor,IDC_RB_BC
		.elseif wParam == IDC_RB_TC      ; Radio button textcolor
			Invoke GetDlgItem,hWin,IDC_IMG_TC
			mov hImg.hImgCur,eax
			mov dwCurRB,4
			Invoke SetListColor,IDC_RB_TC
		.endif
		
	.elseif	uMsg == WM_CLOSE
		invoke DeleteObject,hFont
		Invoke GdiplusShutdown,hGDIplus
		Invoke EndDialog,hWin,0
	.endif

	xor	eax,eax
	ret	

DlgColor endp

SetListColor PROC idRButton:DWORD

Local dwItemID:DWORD

;-- retrieve color related to rbutton
	.if idRButton == IDC_RB_FC0         ; Radio button forecolor 0%
		mov eax,clpgDNew.dwForeColor000
	.elseif idRButton == IDC_RB_FC50    ; Radio button forecolor 50%
		mov eax,clpgDNew.dwForeColor050
	.elseif idRButton == IDC_RB_FC100   ; Radio button forecolor 100%
		mov eax,clpgDNew.dwForeColor100
	.elseif idRButton == IDC_RB_BC      ; Radio button backcolor
		mov eax,clpgDNew.dwColorBckgr
	.elseif idRButton == IDC_RB_TC      ; Radio button textcolor
		mov eax,clpgDNew.dwColorText
	.endif
	
;-- compare colors in list with current one
	lea edx,dwColYellowGreen
	mov ecx,140
	@@:
	cmp eax,[edx]
	je @F
	sub ecx,1
	js @F
	sub edx,4
	jmp @B
	@@:
	mov dwItemID,ecx    ; holds -1 for no match ;)
	
	Invoke SendDlgItemMessage,hDlgColor,IDC_LISTBOX,LB_SETTOPINDEX,dwItemID,0
	Invoke SendDlgItemMessage,hDlgColor,IDC_LISTBOX,LB_SETCURSEL,dwItemID,0
	
	Ret
SetListColor EndP


ListBoxProc proc uses ebx hCtl:DWORD,uMsg:DWORD,wParam :DWORD,lParam:DWORD
Local hClpg:DWORD

	.if uMsg == WM_LBUTTONDBLCLK
		invoke SendMessage,hCtl,LB_GETCURSEL,0,0
	;-- Get matching color value
		lea edx,dwColAliceBlue
		shl eax,2
		add edx,eax
		mov ebx,[edx]

		Invoke GetDlgItem,hDlgColor,IDC_CPULOAD
		mov hClpg,eax
	;-- Store color in new color struc as requested
		.if dwCurRB == 0
			mov clpgDNew.dwForeColor000,ebx
			Invoke PostMessage,hClpg,WM_CLPG_SET_COLOR000,0,clpgDNew.dwForeColor000
		.elseif dwCurRB == 1
			mov clpgDNew.dwForeColor050,ebx
			Invoke PostMessage,hClpg,WM_CLPG_SET_COLOR050,0,clpgDNew.dwForeColor050
		.elseif dwCurRB == 2
			mov clpgDNew.dwForeColor100,ebx
			Invoke PostMessage,hClpg,WM_CLPG_SET_COLOR100,0,clpgDNew.dwForeColor100
		.elseif dwCurRB == 3
			mov clpgDNew.dwColorBckgr,ebx
			Invoke PostMessage,hClpg,WM_CLPG_SET_BACKCOLOR,0,clpgDNew.dwColorBckgr
		.else
			mov clpgDNew.dwColorText,ebx
			Invoke PostMessage,hClpg,WM_CLPG_SET_TEXTCOLOR,0,clpgDNew.dwColorText
		.endif

		invoke DrawImage,hImg.hImgCur,ebx
		Invoke PostMessage,hClpg,WM_CLPG_SET_NEWVALUE,0,95
	.endif
	
    invoke CallWindowProc,lpListBox,hCtl,uMsg,wParam,lParam
    ret
    
ListBoxProc EndP

ImageProc000 proc hCtl:DWORD,uMsg:DWORD,wParam :DWORD,lParam:DWORD
Local ps:PAINTSTRUCT

	.if uMsg == WM_PAINT
		Invoke BeginPaint,hCtl,ADDR ps
		Invoke DrawImage,hCtl,clpgDNew.dwForeColor000
		Invoke EndPaint,hCtl,ADDR ps
	.endif
	
    invoke CallWindowProc,lpImg000,hCtl,uMsg,wParam,lParam
    ret
    
ImageProc000 EndP

ImageProc050 proc hCtl:DWORD,uMsg:DWORD,wParam :DWORD,lParam:DWORD
Local ps:PAINTSTRUCT

	.if uMsg == WM_PAINT
		Invoke BeginPaint,hCtl,ADDR ps
		Invoke DrawImage,hCtl,clpgDNew.dwForeColor050
		Invoke EndPaint,hCtl,ADDR ps
	.endif
	
    invoke CallWindowProc,lpImg050,hCtl,uMsg,wParam,lParam
    ret
    
ImageProc050 EndP

ImageProc100 proc hCtl:DWORD,uMsg:DWORD,wParam :DWORD,lParam:DWORD
Local ps:PAINTSTRUCT

	.if uMsg == WM_PAINT
		Invoke BeginPaint,hCtl,ADDR ps
		Invoke DrawImage,hCtl,clpgDNew.dwForeColor100
		Invoke EndPaint,hCtl,ADDR ps
	.endif
    invoke CallWindowProc,lpImg100,hCtl,uMsg,wParam,lParam
    ret
    
ImageProc100 EndP

ImageProcBck proc hCtl:DWORD,uMsg:DWORD,wParam :DWORD,lParam:DWORD
Local ps:PAINTSTRUCT

	.if uMsg == WM_PAINT
		Invoke BeginPaint,hCtl,ADDR ps
		Invoke DrawImage,hCtl,clpgDNew.dwColorBckgr
		Invoke EndPaint,hCtl,ADDR ps
		
	.endif
	
    invoke CallWindowProc,lpImgBck,hCtl,uMsg,wParam,lParam
    ret
    
ImageProcBck EndP

ImageProcTxt proc hCtl:DWORD,uMsg:DWORD,wParam :DWORD,lParam:DWORD
Local ps:PAINTSTRUCT

	.if uMsg == WM_PAINT
		Invoke BeginPaint,hCtl,ADDR ps
		Invoke DrawImage,hCtl,clpgDNew.dwColorText
		Invoke EndPaint,hCtl,ADDR ps
	.endif
    invoke CallWindowProc,lpImgTxt,hCtl,uMsg,wParam,lParam
    ret
    
ImageProcTxt EndP

DrawImage Proc hImage:DWORD,dwColor:DWORD

Local graphics:DWORD
Local brush:DWORD
local rct:RECTL
	
	invoke GdipCreateFromHWND,hImage,ADDR graphics
	Invoke GdipGetVisibleClipBoundsI,graphics,ADDR rct
	invoke GdipCreateSolidFill,dwColor,ADDR brush
	invoke GdipFillRectangleI,graphics,brush,rct.left,rct.top,rct.right,rct.bottom
	invoke GdipDeleteBrush,brush
	invoke GdipDeleteGraphics,graphics
	ret
	
DrawImage EndP

GetClpgSettings PROC hCtrl:DWORD

	Invoke ClpgGetData,hCtrl,ADDR clpgD
	Invoke ClpgGetData,hCtrl,ADDR clpgDNew
	ret
	
GetClpgSettings EndP

CreateFontBold PROC hWndParent:DWORD,idCtrl:DWORD

Local logF:LOGFONT
Local hControl:HANDLE
Local hdc:HANDLE

;-- retrieve handle of control
	Invoke GetDlgItem,hWndParent,idCtrl
	mov hControl,eax
;-- retrieve the handle of the font used by the control
	Invoke SendMessage,hControl,WM_GETFONT,0,0
	mov edx,eax
;-- retrieve information about the font object
	Invoke GetObject,edx,SIZEOF logF,ADDR logF
;-- Set font weight property to bold
	mov logF.lfWeight,FW_SEMIBOLD			
;-- Create new (bold) font object
	invoke CreateFontIndirect,ADDR logF
;-- Returns handle to new font in eax, NULL for error
	ret
CreateFontBold EndP

SetControlFont PROC hWndParent:DWORD,idCtrl:DWORD

	;-- retrieve handle of control
	Invoke GetDlgItem,hWndParent,idCtrl
	mov edx,eax
	Invoke SendMessage,edx,WM_SETFONT,hFont,TRUE
	
	Ret
SetControlFont EndP