.CODE

_InitPdhCounter PROC uses ebx hWnd:DWORD

Local pcpe:PDH_COUNTER_PATH_ELEMENTS
Local os:OSVERSIONINFO
Local dwBufferSize:DWORD
Local lpszCntPath:DWORD

	IF LOGMODE
		Invoke WriteLogFile,ADDR szProcName,0,0,0,0
	ENDIF
;-- Get pointer to CpuPgBar struct
	Invoke GetWindowLong,hWnd,0
	mov ebx,eax
	ASSUME ebx:PTR CpuPgBar
	IF LOGMODE
		Invoke WriteLogFile,0,SADD("GetWindowLong:",13,10),SADD("NONZERO "),eax,1
	ENDIF
;-- Determine if at least Win NT 4.0 is installed
	mov	os.dwOSVersionInfoSize,sizeof(OSVERSIONINFO)
	Invoke GetVersionEx,ADDR os
	IF LOGMODE
		Invoke WriteLogFile,0,SADD("GetVersionEx:",13,10),SADD("NONZERO "),eax,1
	ENDIF
	.if (os.dwPlatformId < 2) || (os.dwMajorVersion < 3)
		mov eax,-1 ; wrong platform
		jmp _exitW
	.endif
	
;-- RETRIEVE THE LOCALIZED LANGUAGE STRING

;-- Retrieve the computer name
	mov dwBufferSize,MAX_COMPUTERNAME_LENGTH+1
	Invoke GlobalAlloc,GPTR,dwBufferSize
	mov pcpe.szMachineName,eax
	IF LOGMODE
		Invoke WriteLogFile,0,SADD("GlobalAlloc:",13,10),SADD("NONZERO "),eax,1
	ENDIF
	
;-- This one failed on some machines...???
;	Invoke GetComputerNameEx,ComputerNameDnsFullyQualified,pcpe.szMachineName,ADDR dwBufferSize
;	IF LOGMODE
;		Invoke WriteLogFile,0,SADD("GetComputerNameEx:",13,10),SADD("NONZERO "),eax,1
;	ENDIF
;-- so we go this way:
	Invoke GetComputerName,pcpe.szMachineName,ADDR dwBufferSize
	IF LOGMODE
		Invoke WriteLogFile,0,SADD("GetComputerName:",13,10),SADD("NONZERO "),eax,1
		Invoke WriteLogFile,0,pcpe.szMachineName,SADD("ComputerName "),eax,1
	ENDIF	
	
;-- Retrieve performance object name by index: "Processor"
	mov dwBufferSize,MAX_PATH
	Invoke GlobalAlloc,GPTR,dwBufferSize
	mov pcpe.szObjectName,eax
	IF LOGMODE
		Invoke WriteLogFile,0,SADD("GlobalAlloc:",13,10),SADD("NONZERO "),eax,1
	ENDIF
	Invoke PdhLookupPerfNameByIndex,pcpe.szMachineName,238,pcpe.szObjectName, ADDR dwBufferSize
	IF LOGMODE	
		Invoke WriteLogFile,0,SADD("PdhLookupPerfNameByIndex:",13,10),SADD("0       "),eax,1
	ENDIF
;-- Retrieve performance object name by index: "% Processor Time"
	mov dwBufferSize,MAX_PATH
	Invoke GlobalAlloc,GPTR,dwBufferSize
	mov pcpe.szCounterName,eax
	Invoke PdhLookupPerfNameByIndex,pcpe.szMachineName,6,pcpe.szCounterName, ADDR dwBufferSize
	IF LOGMODE	
		Invoke WriteLogFile,0,SADD("PdhLookupPerfNameByIndex:",13,10),SADD("0       "),eax,1
	ENDIF
		
;-- Initialize other parts of PDH_COUNTER_PATH_ELEMENTS struct
	lea edx,szInstName				; "0"
	mov pcpe.szInstanceName,edx
	mov pcpe.szParentInstance,eax	; NULL
	mov pcpe.dwInstanceIndex,eax    ; NULL
	
;-- Create a full counter path
	mov dwBufferSize,PDH_MAX_COUNTER_PATH
	Invoke GlobalAlloc,GPTR,dwBufferSize
	mov lpszCntPath,eax
	IF LOGMODE
		Invoke WriteLogFile,0,SADD("GlobalAlloc:",13,10),SADD("NONZERO "),eax,1
	ENDIF
	Invoke PdhMakeCounterPath,ADDR pcpe,lpszCntPath,ADDR dwBufferSize,0
	IF LOGMODE	
		Invoke WriteLogFile,0,SADD("PdhMakeCounterPath:",13,10),SADD("0       "),eax,1
		Invoke WriteLogFile,0,lpszCntPath,SADD("CounterPath"),eax,1
	ENDIF
;-- Create a PDH Query
	Invoke PdhOpenQuery,0,0,ADDR [ebx].hQuery
	IF LOGMODE
		Invoke WriteLogFile,0,SADD("PdhOpenQuery:",13,10),SADD("0       "),eax,1
	ENDIF
;-- Add a counter to the query for the counterPath specified.
	Invoke PdhAddCounter,[ebx].hQuery,lpszCntPath,0,ADDR [ebx].hCounter
	IF LOGMODE
		Invoke WriteLogFile,0,SADD("PdhAddCounter:",13,10),SADD("0       "),eax,1
	ENDIF
	test eax,eax
	jnz _exit		; something went wrong !?
	
	Invoke PdhCollectQueryData,[ebx].hQuery
	IF LOGMODE
		Invoke WriteLogFile,0,SADD("PdhCollectQueryData:",13,10),SADD("0       "),eax,1
	ENDIF
	Invoke SetTimer,[ebx].hWndCtrl,1,[ebx].uElapse,ADDR TimerProcNT
	mov [ebx].TimerID,eax
	IF LOGMODE
		Invoke WriteLogFile,0,SADD("SetTimer:",13,10),SADD("NONZERO "),eax,1
	ENDIF
_exit:
	Invoke GlobalFree,pcpe.szMachineName
	Invoke GlobalFree,pcpe.szObjectName
	Invoke GlobalFree,pcpe.szCounterName
	Invoke GlobalFree,lpszCntPath

_exitW:
	ASSUME ebx:NOTHING
	RET
_InitPdhCounter EndP

_CleanupPdhCounter Proc uses ebx hWnd:DWORD

Local hCt:DWORD

;-- Get pointer to CpuPgBar struct
	Invoke GetWindowLong,hWnd,0
	mov ebx,eax
	ASSUME ebx:PTR CpuPgBar
	
;-- Kill the timer first
    Invoke KillTimer,[ebx].hWndCtrl,[ebx].TimerID
;-- If hCounter has been created
	.if [ebx].hCounter != 0
		Invoke PdhRemoveCounter,[ebx].hCounter
	.endif
;-- If hQuery has been created
	.if [ebx].hQuery != 0
		Invoke PdhCloseQuery,[ebx].hQuery
	.endif
	
	xor eax,eax
	ASSUME ebx:NOTHING
	RET
	
_CleanupPdhCounter EndP

TimerProcNT proc USES ebx hWnd:DWORD, uMsg:DWORD, idEvent:DWORD, dwTime:DWORD

Local pfc:PDH_FMT_COUNTERVALUE

;-- Get pointer to CpuPgBar struct
	Invoke GetWindowLong,hWnd,0
	mov ebx,eax
	ASSUME ebx:PTR CpuPgBar

	Invoke PdhCollectQueryData,[ebx].hQuery
;-- Read new data
	Invoke PdhGetFormattedCounterValue,[ebx].hCounter,PDH_FMT_LONG,0,ADDR pfc
;-- Check for valid data
	.if pfc.CStatus == PDH_CSTATUS_VALID_DATA
		mov edx,pfc.longValue
	;-- Draw only if necessary (new value)
	    .if edx != [ebx].dwValue    
	    ;-- Store longvalue in struct
	        mov [ebx].dwValue,edx		; value converted to string
	        mov [ebx].dwRelPos,edx		; position to draw
		;-- Convert to string
			invoke dwtoa,edx,ADDR [ebx].szBuffer
			lea edx,[ebx].szBuffer
		; --- get ascii string length in ecx and convert to unicode
			lea edx,[ebx].szBuffer				
			xor ecx,ecx					; initialize counter
			mov al,[edx]				; get first character
		@@:
			cmp al,0					; String end?
			je @F						; if so => ready
			push edx
			lea edx,[ebx].szWBuffer		; address of unicode text
			mov [edx+ecx*2],al			; write character
			pop edx
			add ecx,1					; increase counter
			mov al,[edx+ecx]			; get next character
			jmp @B					    ; continue
		@@:	
			lea edx,[ebx].szWBuffer
;			mov al," "
;			mov [edx+ecx*2],al
;			add ecx,1
			mov al,"%"
			mov [edx+ecx*2],al          ; write %
			xor eax,eax
			add ecx,1
			mov [edx+ecx*2],ax			; add terminating zero word
			mov [ebx].dwStrLen,ecx      ; store number of characters
			
            invoke PostMessage,hWnd,WM_CLPG_NEW_DATA,0,0
		.endif
	.endif
	
	xor eax,eax
	ASSUME ebx:NOTHING
	RET
TimerProcNT EndP

